Summary:   NNTP server for small sites
Name:      leafnode
Version:   1.6.2
Release:   2
URL:       http://www.troll.no/freebies/leafnode.html
Source0:   ftp://wpxx02.toxi.uni-wuerzburg.de/pub/%{name}-%{version}.tar.gz
Source1:   texpire.cron
Source2:   leafnode.config
Copyright: distributable
Group:     Networking/News
BuildRoot: /tmp/%{name}-%{version}-root

%description
Leafnode is a USENET software package designed for small sites, with a few
tens of readers and only a slow link to the net.

%prep
%setup -q

%build
make CFLAGS="$RPM_OPT_FLAGS" PREFIX_USR=/usr

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT/usr/{sbin,lib/leafnode,man/man1,man/man8}
install -d $RPM_BUILD_ROOT/etc/cron.daily

make PREFIX_USR=$RPM_BUILD_ROOT/usr \
     PREFIX_VAR=$RPM_BUILD_ROOT/var \
     LIBDIR=$RPM_BUILD_ROOT/usr/lib \
     LOCKFILE=$RPM_BUILD_ROOT/var/lock/news/fetch.lck \
     install

install -m 755 -g root -o root %SOURCE1 $RPM_BUILD_ROOT/etc/cron.daily
install -m 644 -g news -o news %SOURCE2 $RPM_BUILD_ROOT/usr/lib/leafnode/config
rm -f $RPM_BUILD_ROOT/usr/sbin/texpire.cron

strip $RPM_BUILD_ROOT/usr/sbin/{checkgroups,fetch,leafnode,texpire}

%post
if [ `grep leafnode /etc/inetd.conf | wc -l` = 0 ] ; then
	echo "nntp	stream	tcp	nowait	news	/usr/sbin/tcpd	/usr/sbin/leafnode" >> /etc/inetd.conf
fi
if [ -f /var/run/inetd.pid ] ; then
	kill -HUP `cat /var/run/inetd.pid` 2> /dev/null ||:
fi

SPOOLDIR=/var/spool/news
LIBDIR=/usr/lib/leafnode

if [ ! -d ${SPOOLDIR}/leaf.node ]
then
    exit 1
fi

if [ -f ${LIBDIR}/groupinfo ]
then
    if [ -f ${SPOOLDIR}/leaf.node/groupinfo ]
    then
        exit 1
    fi

    echo Creating new file for main server ...
    if [ -f ${LIBDIR}/config.rpmsave ]
    then
        CONFILE=${LIBDIR}/config.rpmsave
    else
    CONFILE=${LIBDIR}/config
    fi
    server=`awk '{ if ($1 == "server") printf("%s\n", substr($0,index($0,"=")+1)); }' < ${CONFILE} | tr -d '       '`
    cd ${SPOOLDIR}/interesting.groups
    ls -c1 | xargs -i@@ grep @@\  ${LIBDIR}/groupinfo | \
        cut -d\  -f 1,4 > ${SPOOLDIR}/leaf.node/$server
    echo Converting groupinfo file ...
    echo Your old groupinfo file will be in ${SPOOLDIR}/leaf.node/groupinfo.old
    awk '{ printf("%s %d %d 0", $1, $2, $3); for (i = 5; i <= NF; i++) printf(" %s", $i); printf("\n"); }' < ${LIBDIR}/groupinfo > ${SPOOLDIR}/leaf.node/groupinfo
    mv ${LIBDIR}/groupinfo ${SPOOLDIR}/leaf.node/groupinfo.old
    echo Move other files ...
    find ${LIBDIR} -type f -not -name 'config*' -exec mv '{}' ${SPOOLDIR}/leaf.node/ \;
    chown news.news ${SPOOLDIR}/leaf.node/*
    chmod 664 ${SPOOLDIR}/leaf.node/*
    echo Done.
    exit 0
fi

%postun
if [ "$1" = "0" ]; then
	grep -v leafnode /etc/inetd.conf | grep -v /bin/sh > /etc/inetd.conf.new
	mv /etc/inetd.conf.new /etc/inetd.conf
fi
if [ -f /var/run/inetd.pid ] ; then
        kill -HUP `cat /var/run/inetd.pid` 2> /dev/null ||:
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc CHANGES README TODO archivefaq.pl
%config /etc/cron.daily/texpire.cron
%attr(755,news,news) %dir /usr/lib/leafnode
%attr(600,news,news) %config /usr/lib/leafnode/config
%attr(644,root,man) /usr/man/man1/*
%attr(644,root,man) /usr/man/man8/*
%attr(755,news,news) /usr/sbin/*
%attr(755,news,news) %dir /var/lock/news
%attr(2755,news,news) %dir /var/spool/news
%attr(755,news,news) %dir /var/spool/news/*
%attr(755,news,news) %dir /var/spool/news/message.id/*

%changelog
* Thu Nov 05 1998 Arne Coucheron <arneco@online.no>
  [1.6.2-2]
- %doc dir was not readable by ordinary users, fixed!
- made config file readable by owner only, to prevent unauthorized users
  from getting hold of passwords

* Fri Oct 23 1998 Arne Coucheron <arneco@online.no>
  [1.6.2-1]

* Wed Oct 14 1998 Arne Coucheron <arneco@online.no>
  [1.6.1-1]
- can someone please send me a patch to get rid of all the LOG_DEBUG
  messages so that the operation of leafnode can be speeded up

* Thu Sep 10 1998 Arne Coucheron <arneco@online.no>
  [1.5-2]
- using %%{name} and %%{version} macros
- added -q parameter to %setup
- added patches from Michael Schwendt <sidplay@geocities.com>

* Thu May 07 1998 Arne Coucheron <arneco@online.no>
  [1.5-1]
- cleaned out older changelogs
- some adjustments to the spec file